wood_thickness=6.5;


foot_width=11.9;
foot_height=wood_thickness - .1;
foot_length=wood_thickness;

nut_length=4;
nut_height=6.1;
nut_width=nut_height * sin(60);
nut_offset=7.5;

bolt_offset = 3;
bolt_dia=3.2;

switch_slot_width=20.4;
switch_slot_length=10.4;
switch_slot_depth=6.5;
switch_wiring_width=12.1;
switch_rim_width=1;
switch_mount_width = switch_slot_width + switch_rim_width*2;
switch_hole_dia=1.7;
switch_hole_separation=9.4;
switch_hole_offset=10.2 - 2.5;
switch_offset=16.0;

base_height=10.5;
base_length=nut_offset + nut_length;
base_bottom=-base_height/2;

right_extent=switch_offset + switch_slot_width/2 + switch_rim_width;
left_extent=foot_width + (base_height - foot_height)/2;
y_extent=7.5 + switch_slot_length + switch_rim_width;
z_extent=17.00;

union() {
  difference() {
    union() {
      switch_mount();
      base();
      foot();
    }
    bolt_hole();
  }
}

module switch_mount() {
  union() {
    difference() {
      translate([-right_extent, y_extent - switch_slot_length - switch_rim_width, base_bottom])
        cube([switch_slot_width + switch_rim_width*2, switch_slot_length + switch_rim_width, z_extent - base_bottom]);
      switch_slot();
      rotate([0, -90, 0]) linear_extrude(100)
        polygon([[-100, base_length], [base_bottom + 6, base_length],
          [z_extent - switch_slot_depth - switch_rim_width, y_extent],
	  [0, 100], [-100, y_extent]]);
      translate([-switch_offset + switch_slot_width/2 - switch_wiring_width,
        switch_rim_width,
	z_extent - switch_slot_depth])
        cube([switch_wiring_width,
          y_extent - switch_slot_length - switch_rim_width,
          switch_slot_depth]);
      switch_holes();
    }
  }
}

module switch_slot() {
  translate([-switch_offset - switch_slot_width/2,
    y_extent - switch_slot_length, z_extent - switch_slot_depth])
    cube([switch_slot_width, switch_slot_length, switch_slot_depth]);
}

module switch_backstop() {
  intersection() {
    translate([-switch_offset - switch_slot_width/2, 0, z_extent - switch_slot_depth])
      linear_extrude(switch_slot_depth)
      square([switch_slot_width - switch_wiring_width, y_extent - switch_slot_length]);
    switch_slot();
  }
}

module switch_hole() {
  translate([switch_hole_separation/2, 0])
    cylinder(100, switch_hole_dia/2, switch_hole_dia/2, $fn=32); 
}

module switch_holes() {
  translate([-switch_offset, y_extent - switch_hole_offset, base_bottom + base_height]) {
    switch_hole();
    mirror([1, 0, 0]) switch_hole();
  }
}

module base() {
  translate([0, 0, base_bottom])
    linear_extrude(base_height)
    polygon([[-bolt_offset*2 - base_length, base_length],
    	[left_extent, base_length],
	[left_extent, 0],
	[-bolt_offset*2, 0]]);
  //translate([-right_extent, 0, base_bottom])
  //  cube([right_extent+foot_width + base_height - foot_height, base_length, base_height]);
}

module foot() {
  translate([0, -foot_length, -foot_height/2])
    cube([foot_width, base_length + foot_length, foot_height]);
}

module bolt_hole() {
  translate([-bolt_offset, 0, 0]) {
    rotate([90, 0, 0]) cylinder(100, bolt_dia/2, bolt_dia/2, center=true, $fn=32);
    translate([0, nut_offset]) {
      rotate([-90, 0, 0]) linear_extrude(y_extent) circle(d=nut_height, $fn=6);
    }
  }
}
